// audio_stream_controller.js
//
//
// Except for parts not by Apollia:
//
//    Copyright (C) 2014  Apollia
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as
//    published by the Free Software Foundation, either version 3 of the
//    License, or (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see http://www.gnu.org/licenses/ .
//
//
//    Contact info:     http://astroblahhh.com/contact-apollia.shtml 


Astroblahhh_Music_Player___Object.prototype.Audio_Stream_Controller_Object = function()
{
	var ABPlayer = window.Astroblahhh_Music_Player;
	
	
	this.Stop = function()
	{	
		if (ABPlayer.Audio_Stream !="Not Yet Started")
		{
			ABPlayer.Audio_Stream.stop();
		}
		
		ABPlayer.Audio_Stream_Status.Draw_PlayPause_Button("Play");
	}
	
	this.Play = function()
	{	
		
		ABPlayer.Audio_Stream.play();
		ABPlayer.Audio_Stream_Status.Draw_PlayPause_Button("Pause");
	}
	this.Pause = function()
	{
		ABPlayer.Audio_Stream.pause();
		ABPlayer.Audio_Stream_Status.Draw_PlayPause_Button("Play");
	}
	this.Set_Position = function (milliseconds)
	{
		if (ABPlayer.Audio_Stream!="Not Yet Started")
		{	ABPlayer.Audio_Stream.setPosition(milliseconds);
		}
	}
	this.Play_Current_Queued_Track = function()
	{	
		this.Play_Track_from_Queue(ABPlayer.Queue_Overlord.Current_Queue, ABPlayer.Queue_Overlord.Current_Queue.Position );
		
	}
	this.Play_Prev_Queued_Track = function()

	{	ABPlayer.Queue_Overlord.Move_to_Prev_Track();
		
		ABPlayer.Audio_Stream_Controller.Play_Current_Queued_Track();
	}
	this.Play_Next_Queued_Track = function()
	{	var should_proceed;
	
		should_proceed = ABPlayer.Queue_Overlord.Move_to_Next_Track();
		
		if (should_proceed)
		{
			ABPlayer.Audio_Stream_Controller.Play_Current_Queued_Track();
		}
	}
	this.Wait_x_Milliseconds_Then_Start_Next_Track = function( milliseconds)
	{
		
		setTimeout( function() { ABPlayer.Audio_Stream_Controller.Play_Next_Queued_Track(); }, milliseconds );
		
		return true;
		
	}

	
	this.Play_Track_from_Queue = function (queue_name, queue_arrin )
	{	
		var Provincial_Audio_Stream_Creator_Function;
		
		Provincial_Audio_Stream_Creator_Function=ABPlayer.Config.Provincial_Audio_Stream_Creator_Function;
		
		
		ABPlayer.Audio_Stream_Controller.Stop();
		
		Provincial_Audio_Stream_Creator_Function();
		
		ABPlayer.Audio_Stream_Controller.Play();
		
	}


	this.Play_or_Toggle_Pause = function( )
	{	
		if (ABPlayer.Audio_Stream=="Not Yet Started")
		{	
			
			ABPlayer.Audio_Stream_Controller.Play_Current_Queued_Track();
			return true;
		}
		//window.alert("Playstate " + ABPlayer.Audio_Stream.playState);
		
		if (ABPlayer.Audio_Stream.paused )
		{	
			ABPlayer.Audio_Stream_Controller.Play();
		}
		else
		{	
			if (ABPlayer.Audio_Stream.playState==0) //stopped
			{	
				ABPlayer.Audio_Stream_Controller.Play_Current_Queued_Track();

				return true;
			}
			ABPlayer.Audio_Stream_Controller.Pause();
		}

	}
}