// mp3-player.js
//
//
// Except for parts not by Apollia:
//
//    Copyright (C) 2014  Apollia
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as
//    published by the Free Software Foundation, either version 3 of the
//    License, or (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see http://www.gnu.org/licenses/ .
//
//
//    Contact info:     http://astroblahhh.com/contact-apollia.shtml 


function MP3_Player___Object(Args)
{	
	var MP3_Player=this;
	var ABPlayer = window.Astroblahhh_Music_Player;
	
	this.Run = function ()
	{	
		ABPlayer.Run();
	
		ABPlayer.Layout_Overlord.Output_Layout();
		
		MP3_Player.Queue_Overlord=new MP3_Player.Queue_Overlord_Object();
		
		if (ABPlayer.Volume_Overlord.Current_Volumebar_Style=="Vertical")
		{
			ABPlayer.Widget_Click_Overlord.Set_Up_Vertical_Volume_Bar();
			
		}
		ABPlayer.Volume_Overlord.Update_Volumebar(ABPlayer.Config.default_volume);
		
		
		
		ABPlayer.Widget_Click_Overlord.Set_Up_Song_Progress_Bar();
		
		ABPlayer.Widget_Click_Overlord.Set_Up_Audio_Control_Buttons();
		
		
		ABPlayer.Queue_Overlord.Create_New_Queue("Main_Queue");
		
		ABPlayer.Queue_Overlord.Set_Current_Queue_to_("Main_Queue");
		
		
		// If you want to listen to some excellent full-length, legally free MP3s,
		// download the below remixes, put them in your web server folder,
		// and uncomment the non-URL lines below.

		
		//ABPlayer.Queue_Overlord.Add_Track_to_Queue( { url: "mellogear_-_Cosmo_Candle.mp3" } );
		// http://vgremix.com/songs/cosmo-candle
		
		//ABPlayer.Queue_Overlord.Add_Track_to_Queue( { url: "ThisIsTotallyNotSirJ_-_Nightfall.mp3" } );
		// http://vgremix.com/songs/nightfall
		
		
		//ABPlayer.Queue_Overlord.Add_Track_to_Queue( { url: "Theory_of_N_-_Stealth_Chameleon.mp3" } );
		// http://vgremix.com/songs/stealth-chameleon
		
		//ABPlayer.Queue_Overlord.Add_Track_to_Queue( { url: "ThisIsTotallyNotSirJ_-_Miracle_Dance.mp3" } );
		// http://vgremix.com/songs/miracle-dance
		
		
		
		// Public domain demo snippets, made from two tracks from MusOpen - http://musopen.org 
		
		ABPlayer.Queue_Overlord.Add_Track_to_Queue( { url: "Erik_Satie1.mp3" } );
		// https://musopen.org/music/349/erik-satie/gymnopedie-no-1-harp-arr/
		
		ABPlayer.Queue_Overlord.Add_Track_to_Queue( { url: "Chopin1.mp3" } );
		ABPlayer.Queue_Overlord.Add_Track_to_Queue( { url: "Chopin2.mp3" } );
		// Both from:
		// https://musopen.org/music/135/frederic-chopin/etude-no-1-from-etudes-op-25/
		
		
		MP3_Player.Queue_Overlord.Display_Queue("Main_Queue");
		
		
		
		
		$("#Main_Queue_Track_List").on("click", ".track", function() 
			{
				var track_id;
				
				queue_id = $(this).attr('ref');
				
				ABPlayer.Queue_Overlord.Set_Position_in_Queue(queue_id);
				
				
				ABPlayer.Audio_Stream_Controller.Play_Current_Queued_Track();

				
			}
		);
		

	}; 
	// # End of Run function
	
	
	
	
	this.Create_Audio_Stream = function()
	{	
		var Current_Queue;	
		var Current_Queue_Position;
		
		var queue_id_string;
	
		
		Current_Queue = ABPlayer.Queue_Overlord.Current_Queue;
		Current_Queue_Position = Current_Queue.Position;
		

		queue_id_string = ABPlayer.Queue_Overlord.Make_Displayable_Queue_Track_ID_String( Current_Queue.name, Current_Queue_Position );
		

		
		ABPlayer.Audio_Stream = soundManager.createSound(
			{

				id: queue_id_string,

				url: ABPlayer.Queue_Overlord.Current_Queue.Tracks[Current_Queue_Position].url,
				
				volume: ABPlayer.Volume_Overlord.Current_Volume
				
			}
		);
		
	}
	
}
