// songbar_overlord.js
//
//
// Except for parts not by Apollia:
//
//    Copyright (C) 2014  Apollia
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as
//    published by the Free Software Foundation, either version 3 of the
//    License, or (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see http://www.gnu.org/licenses/ .
//
//
//    Contact info:     http://astroblahhh.com/contact-apollia.shtml 



Astroblahhh_Music_Player___Object.prototype.Songbar_Overlord_Object = function()
{
	var ABPlayer = window.Astroblahhh_Music_Player;
	
	this.position = undefined;
	this.duration = undefined;
	
	this.Empty_Out_Songbar = function ()
	{	
		$("#Song_Progress_Bar_Filler").css('width', '0');
	}
	
	this.Calculate_New_Position = function(e, posX, posY)
	{	
		// Modified stuff from http://stackoverflow.com/questions/3234977/using-jquery-how-to-get-click-coordinates-on-the-target-element
		
		var posX_inside_container = (e.pageX - posX);
		

		var current_width_of_songbar=$("#Song_Progress_Bar_Border").width();
		
		var how_far_thru_song = posX_inside_container / current_width_of_songbar;
		
		var new_position_in_milliseconds = ABPlayer.Songbar_Overlord.duration * how_far_thru_song;
		
		return new_position_in_milliseconds;
		
	}
	
	
	this.Update_Songbar = function(percentage)
	{	$("#Song_Progress_Bar_Filler").css('width', percentage + '%');
	}
	

	this.Update_Timepos = function()
	{
		var timepos=this.Milliseconds_to_Hours_Minutes_Seconds(this.position);
		
		$("#Song_Timepos_in_Hours_Mins_Secs").html(timepos);
	}
	
	
	this.Milliseconds_to_Hours_Minutes_Seconds = function(milliseconds)
	{
		var hours;
		var mins;
		var secs;
		var result;
		
		
		mydate=new Date(milliseconds);
		
		hours=mydate.getUTCHours();
		hours=('0'  + hours).slice(-2);
		
		mins=mydate.getUTCMinutes();
		mins=('0'  + mins).slice(-2);
		
		secs=mydate.getUTCSeconds();
		secs=('0'  + secs).slice(-2);
		
		result = hours + ":" + mins + ":" + secs;

		return result;
	}
}