// widget_overlord.js
//
//
// Except for parts not by Apollia:
//
//    Copyright (C) 2014  Apollia
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as
//    published by the Free Software Foundation, either version 3 of the
//    License, or (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see http://www.gnu.org/licenses/ .
//
//
//    Contact info:     http://astroblahhh.com/contact-apollia.shtml 


Astroblahhh_Music_Player___Object.prototype.Widget_Overlord_Object = function()
{
	var ABPlayer = window.Astroblahhh_Music_Player;
	
	this.Wrap_Inside_Centering_Divs = function( html_string )
	{	
		var result;
		
		result = "\n	<div class=\"outer-center\">\n		<div class=\"inner-center\">" + html_string + "\n		</div>\n	</div>\n	<div class=\"clear\"></div>";
		
		return result;
	}
	

	
	this.Provide_Song_Details_HTML = function( settings )
	{
		var result;
		var middle="";
		
		result = "<div id=\"Container_of_Song_Details\">";
	
		middle = middle.concat("\n			<div id=\"Song_Details__Title\">");
		middle = middle.concat("\n			</div>");
		middle = middle.concat("\n			<div id=\"Song_Details__Musician\">");
		middle = middle.concat("\n			</div>");
		middle = middle.concat("\n			<div id=\"Song_Details__Album\">");
		middle = middle.concat("\n			</div>");
		
		
		if ( settings && settings.should_wrap_in_centering_divs)
		{	middle = this.Wrap_Inside_Centering_Divs(middle);
		
		}
		result = result.concat(middle);

		result = result.concat("\n</div>");
		
		return result;
		
	}
	this.Provide_Vertical_Volumebar_HTML = function( settings )
	{	
		
		ABPlayer.Volume_Overlord.Current_Volumebar_Style="Vertical";
		
		var result;
		var middle="";
		
		result = "<div id=\"Container_of_Vertical_Volume_Bar_and_Bar_Border\">";
		
		middle = middle.concat("\n			<div id=\"Vertical_Volume_Bar_Border\">");
		middle = middle.concat("\n				<div id=\"Vertical_Volume_Bar_Filler\">");
		middle = middle.concat("\n				</div>");
		middle = middle.concat("\n			</div>");
		
		if (settings && settings.should_wrap_in_centering_divs)
		{	middle = this.Wrap_Inside_Centering_Divs(middle);
		
		}

		result = result.concat(middle);
		
		result = result.concat("\n</div>");
		
		return result;
	}

	this.Provide_HTML_for_Song_Controls_and_Progress_Bar = function( settings )
	{	
		
		var result;
		var middle="";
		result = "<div id=\"Container_of_Song_Controls_and_Progress_Bar\">";
		
		
		middle = middle.concat("\n			<div class=\"hover_color\" id=\"Container_of_Stop_Button\">");
		middle = middle.concat("\n				<div  id=\"Stop_Button\">&#x25FC</div>");
		middle = middle.concat("\n			</div>");
		
		
		
		
		middle = middle.concat("\n			<div class=\"hover_color\" id=\"Container_of_PlayPause_Button\">");
		middle = middle.concat("\n				<div id=\"PlayPause_Button\">&#x2332;</div>");
		middle = middle.concat("\n			</div>");


		middle = middle.concat("\n			<div class=\"hover_color\" id=\"Container_of_Prev_Track_Button\">");
		middle = middle.concat("\n				<div id=\"Prev_Track_Button\">&#x21E6;</div>");
		middle = middle.concat("\n			</div>");
		
		
		middle = middle.concat("\n			<div class=\"hover_color\" id=\"Container_of_Next_Track_Button\">");
		middle = middle.concat("\n				<div id=\"Next_Track_Button\">&#x21E8;</div>");
		middle = middle.concat("\n			</div>");
	

		middle = middle.concat("\n			<div id=\"Song_Progress_Bar_Border\">");
		middle = middle.concat("\n				<div id=\"Song_Progress_Bar_Loading_Filler\"></div>");
		middle = middle.concat("\n				<div id=\"Song_Progress_Bar_Filler\"></div>");
		middle = middle.concat("\n			</div>");

		middle = middle.concat("\n		<span id=\"Song_Timepos_in_Hours_Mins_Secs\">00:00:00</span>");
		
		
		if ( settings && settings.should_wrap_in_centering_divs)
		{	middle = this.Wrap_Inside_Centering_Divs(middle);
		
		}
		
		result = result.concat(middle);
		
		result = result.concat("\n</div>");
		
		return result;
	}
	
}