// volume_overlord.js
//
//
// Except for parts not by Apollia:
//
//    Copyright (C) 2014  Apollia
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as
//    published by the Free Software Foundation, either version 3 of the
//    License, or (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see http://www.gnu.org/licenses/ .
//
//
//    Contact info:     http://astroblahhh.com/contact-apollia.shtml 



Astroblahhh_Music_Player___Object.prototype.Volume_Overlord_Object = function()
{
	var ABPlayer = window.Astroblahhh_Music_Player;
	
	var Config = ABPlayer.Config;
	
	
	this.Current_Volume=Config.default_volume;
	
	this.Current_Volumebar_Style="Vertical";
	
	
		
	this.Calculate_New_Vertical_Volume = function (e, posX, posY)
	{
		// Modified stuff from http://stackoverflow.com/questions/3234977/using-jquery-how-to-get-click-coordinates-on-the-target-element

		var posX_inside_container = (e.pageX - posX);
		var posY_inside_container = (e.pageY - posY);
	
		var current_height_of_volumebar=$("#Vertical_Volume_Bar_Border").height();
		
		
		var complement_of_posY_inside_container = current_height_of_volumebar - posY_inside_container;
		
		
		var new_volume = complement_of_posY_inside_container / current_height_of_volumebar;
		
		new_volume=100*new_volume;
		
		new_volume=Math.floor(new_volume);
		
		return new_volume;
		
	}
	this.Update_Volumebar = function(percentage)
	{	
		var complement_of_percentage=100-percentage;
		
		if ( this.Current_Volumebar_Style == "Vertical")
		{	
			$("#Vertical_Volume_Bar_Filler").css('height', complement_of_percentage + '%');
		}
	}
	this.Set_Audio_Volume = function(percentage)
	{	
		if ( ABPlayer.Audio_Stream != "Not Yet Started" )
		{
			ABPlayer.Audio_Stream.setVolume(percentage);
		}
	}
	this.Set_Audio_Volume_and_Update_Volumebar = function (percentage)
	{	
		if (percentage>100)
		{	percentage=100;
		}
		else if (percentage<0)
		{	percentage=0;
		}
		
		this.Current_Volume=percentage;
		
		this.Set_Audio_Volume(percentage);
		
		this.Update_Volumebar(percentage);	
		
	}

}
	