// widget_click_overlord.js
//
//
// Except for parts not by Apollia:
//
//    Copyright (C) 2014  Apollia
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as
//    published by the Free Software Foundation, either version 3 of the
//    License, or (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see http://www.gnu.org/licenses/ .
//
//
//    Contact info:     http://astroblahhh.com/contact-apollia.shtml 



Astroblahhh_Music_Player___Object.prototype.Widget_Click_Overlord_Object = function()
{
	var ABPlayer = window.Astroblahhh_Music_Player;


	
	this.Set_Up_Audio_Control_Buttons = function()
	{
		$("#Container_of_Stop_Button").on("click", ABPlayer.Audio_Stream_Controller.Stop );
		
		$("#Container_of_PlayPause_Button").on("click", ABPlayer.Audio_Stream_Controller.Play_or_Toggle_Pause );
		
		$("#Container_of_Next_Track_Button").on("click", ABPlayer.Audio_Stream_Controller.Play_Next_Queued_Track );
		
		$("#Container_of_Prev_Track_Button").on("click", ABPlayer.Audio_Stream_Controller.Play_Prev_Queued_Track );
	}
	
	
	
	this.Set_Up_Vertical_Volume_Bar = function()
	{
		$("#Vertical_Volume_Bar_Border").click(
			function (e) 
			{
				var new_volume;
				
				new_volume = ABPlayer.Volume_Overlord.Calculate_New_Vertical_Volume ( e, $(this).offset().left,  $(this).offset().top );
				
				ABPlayer.Volume_Overlord.Set_Audio_Volume_and_Update_Volumebar( new_volume );
			}
		);
	}
	
	
	
	this.Set_Up_Song_Progress_Bar = function()
	{
		$("#Song_Progress_Bar_Border").click(
			function (e) 
			{
				var new_position_in_milliseconds;
				
				new_position_in_milliseconds = ABPlayer.Songbar_Overlord.Calculate_New_Position ( e, $(this).offset().left, $(this).offset().top );
				
				ABPlayer.Audio_Stream_Controller.Set_Position(new_position_in_milliseconds);
				
			}
		);
		
	}

}